/* This file is part of Indico.
 * Copyright (C) 2002 - 2015 European Organization for Nuclear Research (CERN).
 *
 * Indico is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 3 of the
 * License, or (at your option) any later version.
 *
 * Indico is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Indico; if not, see <http://www.gnu.org/licenses/>.
 */

@import 'partials/toolbars';


// ============================================================================
// Base classes and mixins
// ============================================================================

%i-box-title {
    @extend %font-family-title-light;
    color: $dark-blue;
    display: inline-block;
    font-size: 1.5em;
    font-weight: bold;
}

%i-box-description {
    @extend %font-family-description;
    color: $dark-gray;
    font-size: 14px;
}

%box-hr {
    height: 0;
    overflow: hidden;
    background: transparent;
    border: 0;
    border-bottom: 1px solid $gray;
    margin-left: -10px;
    margin-right: -10px;

    &.inline {
        margin-left: 0;
        margin-right: 0;
    }
}


%i-box-empty {
    font-size: 1em;
    font-style: italic;

    display: block;

    text-align: left;

    color: $dark-gray;
}

// ============================================================================
// Boxes
// ============================================================================

.i-box {
    @include border-radius();
    @include box-sizing(border-box);
    @include border-all();
    @include single-box-shadow();

    background: white;
    color: $black;
    padding: 10px;

    hr {
        @extend %box-hr;
    }
    > .empty {
        @extend %i-box-empty;
    }
}

.i-box.titled {
    .i-box-header {
        @include border-bottom();
        background-color: $light-gray;
        margin: -10px -10px;
        padding: 10px 10px;
        overflow: hidden;

        .i-box-header-text {
            float: left;
        }

        .i-box-title {
            @extend %i-box-title;
        }

        .i-box-description {
            @extend %i-box-description;
        }

        .i-box-buttons {
            float: right;
            margin: 0;
            padding: 0;
        }

        .i-box-metadata {
            line-height: $toolbar-thin-height;
            margin: 0 1em;

            > span:not(:last-child) {
                margin-right: 0.7em;
            }

            .label {
                color: $black;
                font-weight: bold;
            }

            .content {
                color: $light-black;
                font-style: italic;
            }
        }
    }

    .i-box-content {
        margin-top: 20px;
        > .empty {
            @extend %i-box-empty;
        }
    }
}

.i-box .i-box-footer {
    background: $light-gray;
    box-shadow: inset 0px 15px 20px -20px $dark-gray;
    margin: 10px -10px -10px;
    padding: 10px;
}

.i-box.no-padding {
    padding: 0;
    &.titled > .i-box-content {
        margin-top: 0;
    }
    > .i-box-header {
        margin: 0;
        padding: 10px;
    }
    > .i-box-content {
        > .empty {
            padding: 10px;
        }
        > ul.group-list {
            margin: 0;
            > li {
                margin: 0;
                margin-right: 0;
                margin-left: 0;
                padding: 10px;
            }
        }
    }
}



// ============================================================================
// Group of boxes
// ============================================================================

.i-box-group {
    $margin: 15px;

    & + & {
        margin-top: $margin;
    }

    &.horz {
        overflow: hidden;
        padding-bottom: $margin;

        .i-box {
            float: left;
            margin-right: $margin;

            &:last-child {
                margin-right: 0px;
            }
        }
    }

    &.vert {
        .i-box{
            margin-bottom: $margin;
            &:last-child {
                margin-bottom: 0px;
            }
        }
    }
}


// ============================================================================
// Boxed group lists
// ============================================================================

.i-box ul.group-list {
    color: $light-black;
    list-style: outside none none;
    margin: 0 0 -10px 0;
    padding: 0;

    > li {
        border-top: 1px solid lighten($gray, $color-variation);
        display: block;
        margin-left: -10px;
        margin-right: -10px;
        padding: 10px 10px;
        overflow: hidden;
    }

    &.content-after {
        > li:last-child {
            border-bottom: 1px solid lighten($gray, $color-variation);
        }
    }

    &.no-content-before {
        margin-top: -20px;

        > li:first-child {
            border-top: 0;
        }
    }

    &.with-buttons {
        line-height: 1.8em;

        .i-button {
            margin-top: 0;
        }
    }

    .list-item-title {
        font-weight: bold;
    }

    .list-item-info {
        margin: 0 1em;

        > span:not(:last-child) {
            margin-right: 0.7em;
        }

        .label {
            font-weight: bold;
        }

        .content {
            font-style: italic;
        }
    }
}
